code/posts/urls.py
"""Posts URLs."""

# Django
from django.urls import path

# Views
from posts import views

urlpatterns = [
    path(
        route="",
        view=views.PostFeedView.as_view(),
        name="feed"
    ),
    path(
        route="posts/new/",
        view=views.CreatePostView.as_view(),
        name="create"
    ),
    path(
        route="posts/<int:pk>/",
        view=views.PostDetailView.as_view(),
        name="detail"
    ),

    
]

code/users/urls.py
"""Users URLs."""

# Django
from django.urls import path
from users.views import SignupView

# Views
from users import views

urlpatterns = [
    

    # Management
    path(
        route='login/',
        view=views.LoginView.as_view(),
        name='login'
    ),
    path(
        route='logout/',
        view=views.LogoutView.as_view(),
        name='logout'
    ),
    path(
        route='signup/',
        view=views.SignupView.as_view(),
        name='signup'
    ),
    path(
        route='me/profile/',
        view=views.UpdateProfileView.as_view(),
        name='update'
    ),
    
    # Posts
    path(
        route='<str:username>/',
        view=views.UserDetailView.as_view(),
        name='detail'
    )

    
]

code/webapp/urls.py
'''Instagram URLs module.'''
# Django
from os import name
from django.contrib import admin
from django.conf.urls.static import static
from django.conf import settings
from django.urls import path, include

from posts import views as posts_views
from users import views as users_views

urlpatterns = [
    path('admin/', admin.site.urls),

    path('', include(('posts.urls', 'posts'), namespace='posts')),
    path('users/', include(('users.urls', 'users'), namespace='users')),

] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

code/posts/models.py
'''Posts models.'''

# Django
from django.db import models
from django.contrib.auth.models import User

# Create your models here.
class Post(models.Model):
    """Post model."""

    user = models.ForeignKey(User, on_delete=models.CASCADE) # Llave foránea con User
    profile = models.ForeignKey('users.Profile', on_delete=models.CASCADE)

    title =  models.CharField(max_length=255)
    photo = models.ImageField(upload_to='posts/photos')

    created = models.DateTimeField(auto_now_add=True)
    modified = models.DateTimeField(auto_now=True)

    def __str__(self):
        """Return title y username."""
        return '{} by @{}'.format(self.title, self.user.username)

code/users/models.py
"""Users models."""

# Django
from django.contrib.auth.models import User
from django.db import models

# Create your models here.
class Profile(models.Model):
    """Profile model.
    Proxy model that extends the base data with other information.
    """

    user = models.OneToOneField(User, on_delete=models.CASCADE)

    website = models.URLField(max_length=200, blank=True)
    biography = models.TextField(blank=True)
    phone_number = models.CharField(max_length=20, blank=True)

    picture = models.ImageField(
        upload_to='users/pictures',
        blank=True,
        null=True
    )

    created = models.DateTimeField(auto_now_add=True)
    modified = models.DateTimeField(auto_now=True)

    def __str__(self):
        """Return username"""
        return self.user.username

code/posts/forms.py
"""Post forms."""

# Django
from django import forms

# Models
from posts.models import Post

class PostForm(forms.ModelForm):
    
    class Meta:
        model = Post
        fields = ("user","profile", "title", "photo")

code/users/forms.py
"""User forms."""

# Django
from django import forms

# Models
from django.contrib.auth.models import User
from users.models import Profile

class SignupForm(forms.Form):
    """Sign up form."""
    username = forms.CharField(min_length=4, max_length=50)
    password = forms.CharField(
        max_length=70,
        widget=forms.PasswordInput()
        )

    password_confirmation = forms.CharField(
        max_length=70,
        widget=forms.PasswordInput()
        )

    first_name = forms.CharField(min_length=2, max_length=50)
    last_name = forms.CharField(min_length=2, max_length=50)

    email = forms.CharField(
        min_length=6, 
        max_length=70,
        widget=forms.EmailInput()
        )

    def clean_username(self):
        """Username must be unique."""
        username = self.cleaned_data['username']
        username_taken = User.objects.filter(username=username).exists()
        if username_taken:
            raise forms.ValidationError('Username is already in use.')
        return username

    def clean(self):
        """Verify password confirmation match."""
        data = super().clean()

        password = data['password']
        password_confirmation = data['password_confirmation']

        if password != password_confirmation:
            raise forms.ValidationError('Password do not match.')

        return data

    def save(self):
        """Create user and profile."""
        data = self.cleaned_data
        data.pop('password_confirmation')

        user = User.objects.create_user(**data)
        profile = Profile(user=user)
        profile.save()

code/posts/views.py
'''Posts views.'''
# Django
from django.urls import reverse_lazy
from django.contrib.auth.mixins import LoginRequiredMixin
from django.urls.base import reverse_lazy
from django.views.generic import ListView, DetailView, CreateView


# Forms
from posts.forms import PostForm

# Models
from posts.models import Post

# Create your views here.
class PostFeedView(LoginRequiredMixin, ListView):
    """Return all publish posts."""
    template_name = 'posts/feed.html'
    model = Post
    ordering = ('-created',)
    paginate_by = 30
    context_object_name = 'posts'

class PostDetailView(LoginRequiredMixin, DetailView):
    """Return post detail."""

    template_name = 'posts/detail.html'
    queryset = Post.objects.all()
    context_object_name = 'post'

class CreatePostView(LoginRequiredMixin, CreateView):
    """Create a new post."""
    template_name = 'posts/new.html'
    form_class = PostForm
    success_url = reverse_lazy('posts:feed')

    def get_context_data(self, **kwargs):
        """Add user and profile to context."""
        context = super().get_context_data(**kwargs)
        context['user'] = self.request.user
        context['profile'] = self.request.user.profile
        return context

code/users/views.py
"""Users views."""

# Django
from django.contrib.auth.decorators import login_required
from django.contrib.auth.mixins import LoginRequiredMixin
from django.contrib.auth import views as auth_views
from django.urls import reverse, reverse_lazy
from django.views.generic import DetailView, FormView, UpdateView

# Models
from django.contrib.auth.models import User
from posts.models import Post
from users.models import Profile

# Forms
from users.forms import SignupForm
queryset = User.objects.all()

# Create your views here.

class UserDetailView(LoginRequiredMixin, DetailView):
    """User detail view."""

    template_name = 'users/detail.html'
    slug_field = 'username'
    slug_url_kwarg = 'username'
    queryset = User.objects.all()
    context_object_name = 'user'

    def get_context_data(self, **kwargs):
        """Add user's posts to context"""
        context = super().get_context_data(**kwargs)
        user = self.get_object()
        context['posts'] = Post.objects.filter(user=user).order_by('-created')
        return context


class UpdateProfileView(LoginRequiredMixin, UpdateView):
    """Update profile view."""

    template_name = 'users/update_profile.html'
    model = Profile
    fields = ['website', 'biography', 'phone_number', 'picture']

    def get_object(self):
        """Return user's profile."""
        return self.request.user.profile

    def get_success_url(self):
        """Return to user's profile."""
        username = self.object.user.username
        return reverse('users:detail', kwargs={'username': username})

class LoginView(auth_views.LoginView):
    """Login view."""

    template_name = 'users/login.html'


class SignupView(FormView):
    """Users sign up view."""

    template_name = 'users/signup.html'
    form_class = SignupForm
    success_url = reverse_lazy('users:login')

    def form_valid(self, form):
        """Save form data."""
        form.save()
        return super().form_valid(form)

class LogoutView(LoginRequiredMixin, auth_views.LogoutView):
    """Logout view."""

    template_name = 'users/logged_out.html'

code/templates/base.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    {% block head_content %}{% endblock %}


    {% load static %}
    <link rel="stylesheet" href="{% static 'css/bootstrap.min.css' %}">
    <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.1.0/css/all.css" crossorigin="anonymous" />
    <link rel="stylesheet" href="{% static 'css/main.css' %}" />

</head>
<body>

    {% include "nav.html" %}

    <div class="container mt-5">
        {% block container %}
        {% endblock%}
    </div>

</body>
</html>

code/templates/nav.html
{% load static %}
<nav class="navbar navbar-expand-lg fixed-top" id="main-navbar">
    <div class="container">

        <a class="navbar-brand pr-5" style="border-right: 1px solid #efefef;" href="{% url 'posts:feed' %}">
            <img src="{% static "img/instagram.png" %}" height="45" class="d-inline-block align-top"/>
        </a>

        <div class="collapse navbar-collapse">
            <ul class="navbar-nav mr-auto">

                <li class="nav-item">
                    <a href="{% url 'users:detail' request.user.username %}">
                        {% if request.user.profile.picture %}
                            <img src="{{ request.user.profile.picture.url }}" height="35" class="d-inline-block align-top rounded-circle"/>
                        {% else %}
                            <img src="{% static 'img/default-profile.png' %}" height="35" class="d-inline-block align-top rounded-circle"/>
                        {% endif %}
                        
                    </a>
                </li>

                <li class="nav-item nav-icon">
                    <a href="{% url 'posts:create' %}">
                        <i class="fas fa-plus"></i>
                    </a>
                </li>

                <li class="nav-item nav-icon">
                    <a href="{% url "users:logout" %}">
                        <i class="fas fa-sign-out-alt"></i>
                    </a>
                </li>

            </ul>
        </div>
    </div>
</nav>

code/templates/pagination.html
<nav>
    <ul class="pagination justify-content-end">
        {% if page_obj.has_previous %}
        <li class="page-item">
            <a href="?page={{ page_obj.previous_page_number }}" class="page-link">
                Previous
            </a>
        </li>
        {% endif %}
        <li class="page-item">
            <a href="#" class="page-link">
                {{ page_obj.number }} of {{ page_obj.paginator.num_pages }}
            </a>
        </li>
        {% if page_obj.has_next %}
        <li class="page-item">
            <a href="?page={{ page_obj.next_page_number }}" class="page-link">
                Next
            </a>
        </li>
        {% endif %}
    </ul>
</nav>

code/templates/posts/detail.html
{% block head_content %}
    <title>Instagram</title>
{% endblock head_content %}
<!DOCTYPE html>
{% block container %}

    <div class="container">
        <div class="row">
            {% include "posts/post_card.html" %}
        </div>
    </div>
{% endblock container %}

code/templates/posts/feed.html
{% extends "base.html" %}

{% block head_content %}
<title>Instagram feed</title>
{% endblock head_content %}

{% block container %}
    <div class="container">
        <div class="row">
      
            {% for post in posts %}
                {% include "posts/post_card.html" %}
            {% endfor %}
        </div>
    </div>

    {% include "pagination.html" %}

{% endblock container %}

code/templates/posts/new.html
{% extends 'base.html' %}

{% block head_content %}
    <title>Create new post</title>
{% endblock head_content %}

{% block container %}
    <div class="container">
        <div class="row justify-content-md-center">
            <div class="col-6 pt-3 pb-3" id="profile-box">
                <h4 class="mb-4">Post a new photo!</h4>
 
                <form method="POST" enctype="multipart/form-data">
                    {% csrf_token %}
 
                    {% for error in form.errors %}
                        <div class="alert alert-danger" role="alert">
                             {% for e in error %}
                                {{ e }}
                            {% endfor %}
                        </div>
                    {% endfor %}

                    <input type="hidden" name="user" value="{{ user.pk }}">
                    <input type="hidden" name="profile" value="{{ profile.pk }}">

                    {# Website field #}
                    <div class="form-group">
                        <input 
                            type="text" 
                            name="title" 
                            class="form-control {% if form.title.errors %}is-invalid{% endif %}" 
                            placeholder="Title"
                        >
                        <div class="invalid-feedback">
                            {% for error in form.title.erros %}{{ error }}{% endfor %}
                        </div>
                    </div>

                    {# Photo field #}
                    <div class="form-group">
                        <label for="photo">Choose your photo:</label>
                        <input 
                            type="file" 
                            class="form-control {% if form.photo.errors %}is-invalid{% endif %}" 
                            name="photo" 
                            placeholder="photo" 
                        >

                        <div class="invalid-feedback">
                            {% for error in form.photo.errors %}{{ error }}{% endfor %}
                        </div>
                    </div>

                    <button type="submit" class="btn btn-primary btn-block mt-5">Publish!</button>
                    
                </form>
            </div>
        </div>
    </div>
{% endblock container %}

code/templates/posts/post_card.html
<div class="col-sm-12 col-md-8 offset-md-2 mt-5 p-0 post-container">
    <div class="media pt-3 pl-3 pb-1">
        <a href="{% url 'users:detail' post.user.username %}">
            <img src="{{ post.profile.picture.url }}" alt="{{ post.user.get_full_name }}" class="mr-3 rounded-circle" height="35">
        </a>
        <div class="media-body">
            <p style="margin-top: 5px;">
                {{ post.user.get_full_name }}
            </p>
        </div>
    </div>

    <img src="{{ post.photo.url }}" alt="{{ post.title }}" style="width: 100%;">

    <p class="mt-1 ml-2">
        <a href="" style="color: #000; font-size: 20px;">
            <i class="far fa-heart"></i>
        </a> 30 likes
    </p>
    <p class="ml-2 mt-0 mb-2">
        <b>{{ post.title }}</b> - <small>{{ post.created }}</small>
    </p>
</div>

code/templates/users/base.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    {% block head_content %}{% endblock %}

    {% load static %}
    <link rel="stylesheet" href="{% static 'css/bootstrap.min.css' %}">
    <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.1.0/css/all.css" crossorigin="anonymous" />
    <link rel="stylesheet" href="{% static 'css/main.css' %}" />

</head>
<body class="h-100">

    <div class="container h-100">
        <div class="row h-100 justify-content-center align-items-center">
            <div class="col-sm-12 col-md-5 col-lg-5 pt-2 pl-5 pr-5 pb-5" id="auth-container">

                <img src="{% static "img/instagram.png" %}" class="img-fluid rounded mx-auto d-block pb-4" style="max-width: 60%;">

                {% block container %}{% endblock%}

            </div>
        </div>
    </div>

</body>
</html>

code/templates/users/detail.html
{% extends 'base.html' %}

{% block head_content %}
    <title>@{{ user.name }} | Instagram</title>
{% endblock head_content %}

{% block container %}
    <div class="container mb-5" style="margin-top: 8em;">
        <div class="row">
            <div class="col-sm-4 d-flex justify-content-center">
                <img src="{{ user.profile.picture.url }}" 
                alt="@{{ user.username }}" 
                class="rounded-circle" 
                width="150px">
            </div>
            <div class="col-sm-8">
                <h2 style="font-weight: 100;">
                    {{ user.username }}
                    {% if user == request.user %}
                        <a 
                            href="{% url 'users:update' %}" 
                            class="ml-5 btn btn-sm btn-outline-info"
                        >
                            Edit profile
                        </a>
                    {% else %}
                        <a 
                            href="" 
                            class="ml-5 btn btn-sm btn-primary"
                        >
                        Follow
                        </a>
                    {% endif %}
                </h2>
                <div class="row mt-2" style="font-size: 1.2em">
                    <div class="col-sm-4"><b>{{ user.profile.posts_count }}785</b></div>
                    <div class="col-sm-4"><b>{{ user.profile.followers }}1,401</b></div>
                    <div class="col-sm-4"><b>{{ user.profile.following }}491</b></div>
                </div>
                <div class="row mt-4">
                    <div class="col-sm-12">
                        <p>{{ user.profile.biography }}</p>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <tr>
    
<div class="container" id="user-posts">
    <div class="row mt-3">
        {% for post in posts %}
            <div class="col-sm-4 pt-5 pb-5 pr-5 pl-5 d-flex justify-content-center align-items-center">
                <a href="" class="border">
                    <img src="{{ post.photo.url }}" alt="{{ post.title }}" class="img-fluid">
                </a>
            </div>
        {% endfor %}
    </div>
</div>

    </tr>
{% endblock container %}

code/templates/users/login.html
{% extends 'users/base.html' %}

{% block head_content %}
    <title>Instagram sign in</title>
{% endblock head_content %}

{% block container %}

    {% if form.errors %}
        <p class="alert alert-danger">
            Your username and password didn't match. Please try again.
        </p>
    {% endif %}

    <form method="POST" action='{% url "users:login" %}'>
        {% csrf_token %}
        <div class="form-group">
            <input type="text" class="form-control" placeholder="Username" name="username">
        </div>
        <div class="form-group">
            <input type="password" class="form-control" placeholder="Password" name="password">
        </div>
        <button class="btn btn-primary btn-block mt-5" type="submit">Sing in!</button>
    </form>

    <p class="mt-4">Don't have an account yet? <a href="{% url 'users:signup' %}">Sign up here.</a></p>

{% endblock container %}

code/templates/users/signup.html
{% extends 'users/base.html' %}

{% block head_content %}
    <title>Instagram sign up</title>
{% endblock head_content %}

{% block container %}

    <form method="POST" action='{% url "users:signup" %}'>
        {% csrf_token %}

        {{ form.as_p }}

        <button class="btn btn-primary btn-block mt-5" type="submit">Register!</button>
    </form>

{% endblock container %}

code/templates/users/update_profile.html
{% extends 'base.html' %}
{% load static%}

{% block head_content %}
    <title>@{{ request.user.username }}  | Update profile</title>

{% endblock head_content %}

{% block container %}

    <div class="row justify-content-md-center">
        <div class="col-6 p-4" id="profile-box">
            <form action={% url 'users:update' %} method="POST" enctype="multipart/form-data">
                {% csrf_token %}

                {% if form.errors %}
                    <p class="alert alert-danger">{{ form.errors }}</p>
                {% endif %}
                <div class="media">
                    {% if profile.picture %}
                        <img src=" {{ profile.picture.url }} " alt="Profile picture" class="rounded-circle" height="50">
                    {% else %}
                        <img src="{% static 'img/default-profile.png' %}" alt="Profile picture" class="rounded-circle" height="50">
                    {% endif %}
                    
                    <div class="media-body">
                        <h5 class="ml-4">@{{ user.username }} | {{ user.get_full_name }}</h5>
                        <p class="ml-4"><input type="file" name="picture" required="true"></p>
                    </div>
                </div>
                
                <hr><br>

                <div class="form-group">
                    <label for="website">Website</label>
                    <input 
                        type="url" 
                        class="form-control" 
                        name="website" 
                        placeholder="Website"
                        value="{{ profile.website }}"
                    >
                </div>

                <div class="form-group">
                    <label for="biography">Biography</label>
                    <textarea name="biography" id="" cols="30" rows="10" class="form-control">{{ profile.biography }}</textarea>
                </div>

                <div class="form-group">
                    <label for="phone_number">Phone number</label>
                    <input 
                        type="text" 
                        class="form-control" 
                        name="phone_number" 
                        placeholder="Phone number" 
                        value="{{ profile.phone_number }}">
                </div>

                <button type="submit" class="btn btn-primary btn-block mt-5">Update info</button>

            </form>
        </div>
    </div>

{% endblock container %}